<?php
/**
 *  @package Virtualmoney
 *  @copyright Copyright (c)2013 JoomPROD
 *  @license GNU General Public License version 3, or later
 */

defined('_JEXEC') or die();
include_once(JPATH_ROOT.'/administrator/components/com_virtualmoney/helpers/format.php');
include_once(JPATH_ROOT.'/administrator/components/com_virtualmoney/helpers/cparams.php');

class VirtualmoneyModelCredits extends FOFModel
{
    public function qn($name) {
        $db = $this->getDbo();        
       if(version_compare(JVERSION, '3.0', 'ge')) {
			return $db->qn($name);
		} elseif(version_compare(JVERSION, '1.6', 'ge')) {
			return  $db->quoteName($name);
		}else {
            return $db->nameQuote($name);
		}           
    }
    
    public function q($name) {
        $db = $this->getDbo();        
        if(version_compare(JVERSION, '1.6', 'ge')) {
			return  $db->q($name);
		}else {
            return $db->Quote($name);
		}           
    }
    
    /**
     * 
     * @param type $overrideLimits
     * @return type
     */
    public function buildQuery($overrideLimits = false) {
		$db = $this->getDbo();
		
		$query = FOFQueryAbstract::getNew($db)
			->select('*')
			->from('#__virtualmoney_credits');
		
		$search = $this->getState('search',null);
        
        $sql_search = '%'.$search.'%';
        
        $queryUsers = FOFQueryAbstract::getNew($db)
                        ->select('id')
                        ->from($this->qn('#__users'))
                        ->where(' ('.
                                ' ('.$this->qn('username').' LIKE '.$this->q($sql_search).') OR'.
                                ' ('.$this->qn('name').' LIKE '.$this->q($sql_search).')'.
                                  ')');
        
		if($search)
		{
			$query->where(
				' ('.
				' ('.$this->qn('user_id').' = '.(int)$search .') OR'.
                    $this->qn('user_id').' IN ('.$queryUsers.') OR '.
				 ' ('.$this->qn('virtualmoney_credit_id').' = '.$this->q($sql_search).')'.
				')'
			);
		}
        
		
		$order = $this->getState('filter_order', 'virtualmoney_credit_id', 'cmd');
		if(!in_array($order, array_keys($this->getTable()->getData()))) $order = 'virtualmoney_credit_id';
		$dir = $this->getState('filter_order_Dir', 'DESC', 'cmd');
		$query->order($order.' '.$dir);

		return $query;
	}
}