<?php
/**
 *  @package Virtualmoney
 *  @copyright Copyright (c)2013 JoomProd
 *  @license GNU General Public License version 3, or later
 */

// Protect from unauthorized access
defined('_JEXEC') or die();
include_once(JPATH_ROOT.'/administrator/components/com_virtualmoney/helpers/format.php');
include_once(JPATH_ROOT.'/administrator/components/com_virtualmoney/helpers/cparams.php');
include_once(JPATH_ROOT.'/administrator/components/com_virtualmoney/helpers/user.php');
include_once(JPATH_ROOT.'/administrator/components/com_virtualmoney/controllers/default.php');

class VirtualmoneyControllerExchange extends VirtualmoneyControllerDefault
{
    /**
     * Return true to avoid a 403 error
     *
     * @return boolean
     */
    public function onBeforeAdd()
	{
        $user = JFactory::getUser();

        //If the user isn't registered, we display the login page
        if($user->guest) {
            $app = JFactory::getApplication();
            $juri = JURI::getInstance();
			$myURI = base64_encode($juri->toString());
            $com = version_compare(JVERSION, '1.6.0', 'ge') ? 'users' : 'user';
			JFactory::getApplication()->redirect(JURI::base().'index.php?option=com_'.$com.'&view=login&return='.$myURI);
        }
		return true;
	}

    /**
     * @return boolean
     */
	public function onBeforeSave() {
        $app = JFactory::getApplication();
		$user		= JFactory::getUser();

        //If the user isn't registered, we display the login page
        if($user->guest) {
            $app = JFactory::getApplication();
            $juri = JURI::getInstance();
			$myURI = base64_encode($juri->toString());
            $com = version_compare(JVERSION, '1.6.0', 'ge') ? 'users' : 'user';
			JFactory::getApplication()->redirect(JURI::base().'index.php?option=com_'.$com.'&view=login&return='.$myURI);
        }

        if(version_compare(JVERSION, '1.6.0', 'ge')) {
            $input = $app->input;

            $userTarget = $input->get('user_id2', 0, 'int');
            $maxCredits = $input->get('max_credits', 0, 'float');
            $credits = $input->get('credits', 0, 'float');
        } else {
            $userTarget = JRequest::getInt('user_id2', 0);
            $maxCredits = JRequest::getFloat('max_credits', 0);
            $credits = JRequest::getFloat('credits', 0);
        }

        //If no user was selected
        if(!$userTarget) {
            $app->redirect( JRoute::_('index.php?option=com_virtualmoney&view=exchange&status=error'), JText::_('COM_VIRTUALMONEY_EXCHANGES_TARGETUSER_NEEDED'),"message" );
        }
        //If the user doesn't enter a proper value in the field
        if(!$credits) {
            $app->redirect( JRoute::_('index.php?option=com_virtualmoney&view=exchange&status=error'), sprintf(JText::_('COM_VIRTUALMONEY_EXCHANGES_CREDIT_ERROR'),VirtualmoneyHelperFormat::getConfigFormatCurrency()->code),"message" );
        }
        //If the user want to give more credit than he owns
        if($maxCredits < $credits) {
            $app->redirect( JRoute::_('index.php?option=com_virtualmoney&view=exchange&status=error'), sprintf(JText::_('COM_VIRTUALMONEY_EXCHANGES_NEED_MORE_CREDITS'),VirtualmoneyHelperFormat::getConfigFormatCurrency()->codePlural),"message" );
        }
		return true;
	}

    /**
     * Redefinition of the function onSave to redirect the user to the correct view
     *
     * @return type
     */
    function save() {
        parent::savenew();
    }

    /**
     *
     * @return boolean
     */
    public function onAfterSave() {
        $app = JFactory::getApplication();
		$user = JFactory::getUser();
        $db = JFactory::getDBO();

        if(version_compare(JVERSION, '1.6.0', 'ge')) {
            $input = $app->input;
            $credits = $input->get('credits', 0, 'float');
            $maxCredits = $input->get('max_credits', 0, 'float');
            $userId2 = $input->get('user_id2', 0, 'int');
        } else {
            $credits = JRequest::getFloat('credits', 0);
            $maxCredits = JRequest::getFloat('max_credits', 0);
            $userId2 = JRequest::getInt('user_id2', 0);
        }

        $user1 = JFactory::getUser();
        $user2 = JFactory::getUser($userId2);

        $query = "SELECT MAX(virtualmoney_exchange_id) FROM #__virtualmoney_exchanges
                  WHERE user_id1 = ".$user1->id."
                  AND   user_id2 = ".$user2->id."
                  AND   credits = ".$credits;

        $db->setQuery($query);

        $exchangeId = $db->loadResult();

        //Add credits to the receiver and remove the same amount from the giver
        include_once(JPATH_ROOT.'/components/com_virtualmoney/lib/core.php');
        Virtualmoney::addCredits($userId2, $credits, sprintf(JText::_('COM_VIRTUALMONEY_TRANSACTION_EXCHANGE_FROM'),VirtualmoneyHelperFormat::getConfigFormatCurrency()->codePlural,VirtualmoneyHelperUser::getUsername($user->id)), 'VirtualMoney_exchange', $exchangeId);
        Virtualmoney::removeCredits($user->id, $credits, sprintf(JText::_('COM_VIRTUALMONEY_TRANSACTION_EXCHANGE_TO'),VirtualmoneyHelperFormat::getConfigFormatCurrency()->codePlural,VirtualmoneyHelperUser::getUsername($user2->id)), 'VirtualMoney_exchange', $exchangeId);

        return true;
    }
}
