<?php
/**
 *  @package Virtualmoney
 *  @copyright Copyright (c)2013 JoomProd
 *  @license GNU General Public License version 3, or later
 */

// Protect from unauthorized access
defined('_JEXEC') or die();
include_once(JPATH_ROOT.'/administrator/components/com_virtualmoney/helpers/format.php');
include_once(JPATH_ROOT.'/administrator/components/com_virtualmoney/helpers/cparams.php');
include_once(JPATH_ROOT.'/administrator/components/com_virtualmoney/controllers/default.php');

class VirtualmoneyControllerPack extends VirtualmoneyControllerDefault
{
    public function onBeforeAdd()
	{
        $user = JFactory::getUser();

        //If the user isn't registered, we display the login page
        if($user->guest) {
            $app = JFactory::getApplication();
            $juri = JURI::getInstance();
			$myURI = base64_encode($juri->toString());
            $com = version_compare(JVERSION, '1.6.0', 'ge') ? 'users' : 'user';
			JFactory::getApplication()->redirect(JURI::base().'index.php?option=com_'.$com.'&view=login&return='.$myURI);
        }
		return true;
	}

    /**
     * Function called when a user buy a pack of credits
     */
	public function gotopayment() {
        $app = JFactory::getApplication();
		$user = JFactory::getUser();
        $db = JFactory::getDbo();

        //If the user isn't registered, we display the login page
        if($user->guest) {
            $app = JFactory::getApplication();
            $juri = JURI::getInstance();
			$myURI = base64_encode($juri->toString());
            $com = version_compare(JVERSION, '1.6.0', 'ge') ? 'users' : 'user';
			JFactory::getApplication()->redirect(JURI::base().'index.php?option=com_'.$com.'&view=login&return='.$myURI);
        }

        if(version_compare(JVERSION, '1.6.0', 'ge')) {
            $input = $app->input;

            $packId = $input->get('pack_id', 0, 'int');
        } else {
            $packId = JRequest::getInt('pack_id', 0);
        }

        //If the selected pack is valid
        if($packId) {
            if(file_exists(JPATH_ROOT.'/components/com_invoicing/lib/core.php')){
                //We include the file who's gonna create the invoice
                include_once(JPATH_ROOT.'/components/com_invoicing/lib/core.php');
            } else {
                echo 'You need to install Invoicing to use this feature.';exit();
            }

            $packModel = FOFModel::getTmpInstance('Packs','VirtualmoneyModel');
            $pack = $packModel->getItem($packId);

            $tax = VirtualmoneyHelperCparams::getParam('tax',0);

            //Creating the required variable for generating an invoice
            $items[0] = (object)array(
                "pack_id" => $pack->virtualmoney_pack_id,
				"name" => $pack->title,
                "description" => VirtualmoneyHelperFormat::formatPrice($pack->credits),
                "quantity" => 1,

                "gross_unit_price" => $pack->price,
                "tax" => $tax,
                "source" => "virtualmoney-pack",
                "source_type" => $packId
            );

            //Creating an order in the database
            $order = new JObject();
            $order->user_id = $user->id;
            $order->credits = $pack->credits;
            $order->description = sprintf(JText::_('COM_VIRTUALMONEY_PACKS_BUY_DESCRIPTION'),$pack->title,$pack->credits.' '.VirtualmoneyHelperFormat::getConfigFormatCurrency()->codePlural);
            $order->created_on = date('Y-m-d H:i:s');
            $order->state = 'Pending';
            $db->insertObject('#__virtualmoney_orders', $order);
            $orderId = $db->insertId();

            //Invoice generation...
            $invoice_id = Invoicing::createInvoice($user->id, $items, "virtualmoney",$orderId, $pack->currency_id);

            //And we redirect the user to the payment page.
            $invoice = new Invoicing();
            $invoice->redirectToPayment($invoice_id);
        } else {
            //If the selected pack isn't valid -> error
            $app->redirect( JRoute::_('index.php?option=com_virtualmoney&view=pack&status=error'), JText::_('COM_VIRTUALMONEY_PACKS_SELECT_ERROR'),"message" );
        }
	}

}
