<?php
/**
 *  @package Virtualmoney
 *  @copyright Copyright (c)2013 JoomPROD
 *  @license GNU General Public License version 3, or later
 */
// Check to ensure this file is within the rest of the framework
defined('JPATH_BASE') or die();

$this->loadHelper('cparams');
$this->loadHelper('format');
?>
<div class="row-fluid">
    <div class="span12">
        <fieldset>
            <legend><?php echo JText::_('COM_VIRTUALMONEY_ACCOUNT'); ?></legend>
<p><?php echo JText::_('COM_VIRTUALMONEY_WELCOME'); ?></p>
            <h4><?php echo JText::_('COM_VIRTUALMONEY_ACCOUNT_RESUME'); ?></h4>
<table id="virtualmoney_resumetable" class="table table-striped table-bordered">
<tr>
	<th>&nbsp;</th>
	<th align="center"><?php echo JText::_('COM_VIRTUALMONEY_TRANSACTION_BALANCE'); ?></th>
</tr>
<tr>
	<td><?php echo JText::_('COM_VIRTUALMONEY_TRANSACTION_SOLDE'); ?></td>
    <td align="right"><?php echo VirtualmoneyHelperFormat::formatPrice($this->credits) ?></td>
</tr>
</table>
<?php if(VirtualmoneyHelperCparams::getParam('payment_module_enabled',0) == 1): ?>
<p>
    <a href="<?php echo JRoute::_('index.php?option=com_virtualmoney&view=pack'); ?>">
        <?php echo htmlspecialchars(sprintf(JText::_('COM_VIRTUALMONEY_BUY_HERE'),VirtualmoneyHelperFormat::getConfigFormatCurrency()->codePlural)); ?>
    </a>
</p>
<?php endif; ?>
            <h4><?php echo JText::_('COM_VIRTUALMONEY_LAST_TRANSACTIONS'); ?></h4>
<table id="virtualmoney_transactiontable" class="table table-striped table-bordered">
<tr>
	<th align="center"><?php echo JText::_('COM_VIRTUALMONEY_TRANSACTION_CREATED_ON'); ?></th>
	<th align="center"><?php echo JText::_('COM_VIRTUALMONEY_TRANSACTION_DESCRIPTION'); ?></th>
	<th align="center"><?php echo JText::_('COM_VIRTUALMONEY_TRANSACTION_DEBIT'); ?></th>
	<th align="center"><?php echo htmlspecialchars(sprintf(JText::_('COM_VIRTUALMONEY_TRANSACTION_CREDIT'),VirtualmoneyHelperFormat::getConfigFormatCurrency()->codePlural)); ?></th>
</tr>
<?php foreach($this->transactions as $transaction) { 
?>
<tr>
	<td><?php echo VirtualmoneyHelperFormat::formattedDate($transaction->created_on);?></td>
    <td>
        <?php
            $description = JText::_($transaction->description);
            $description = str_replace('<br />', '', $description);
            $description = str_replace('&nbsp;', ' ', $description);
            echo nl2br(htmlspecialchars($description));
        ?>
    </td>
	<td align="right"><?php echo $transaction->debit ?></td>
	<td align="right"><?php echo $transaction->credit ?></td>
</tr>
<?php 
} ?>
</table>
<a href="<?php echo JRoute::_('index.php?option=com_virtualmoney&view=transactions'); ?>">
    <?php echo JText::_('COM_VIRTUALMONEY_SEE_ALL_TRANSACTIONS'); ?>
</a>
<?php if(VirtualmoneyHelperCparams::getParam('exchange_module_enabled',0) == 1): ?>
<p>
<a href="<?php echo JRoute::_('index.php?option=com_virtualmoney&view=exchange'); ?>">
    <?php echo htmlspecialchars(sprintf(JText::_('COM_VIRTUALMONEY_GIVE_CREDITS'),VirtualmoneyHelperFormat::getConfigFormatCurrency()->codePlural)); ?>
</a>
</p>
            <?php endif; ?>
        </fieldset>
    </div>
</div>