<?php
/**
 *  @package Virtualmoney
 *  @copyright Copyright (c)2013 JoomPROD
 *  @license GNU General Public License version 3, or later
 */
// Check to ensure this file is within the rest of the framework
defined('JPATH_BASE') or die();

$user = JFactory::getUser();
?>
<div class="row-fluid">
    <div class="span12">
        <fieldset>
            <legend><?php echo JText::_('COM_VIRTUALMONEY_TRANSACTIONS'); ?></legend>
<form action="index.php" method="post" name="adminForm" id="adminForm">

            <h4><?php echo JText::_('COM_VIRTUALMONEY_ACCOUNT_RESUME'); ?></h4>
<table id="virtualmoney_resumetable" class="table table-striped table-bordered">
<tr>
	<th>&nbsp;</th>
	<th align="center"><?php echo JText::_('COM_VIRTUALMONEY_TRANSACTION_BALANCE'); ?></th>
</tr>
<tr>
	<td><?php echo JText::_('COM_VIRTUALMONEY_TRANSACTION_SOLDE'); ?></td>
	<td align="right">
        <?php 
            echo htmlspecialchars(VirtualmoneyHelperFormat::formatPrice($this->credits));
        ?>
    </td>
</tr>
</table>
<p>
    <a href="<?php echo JRoute::_('index.php?option=com_virtualmoney&view=pack'); ?>">
        <?php echo htmlspecialchars(sprintf(JText::_('COM_VIRTUALMONEY_BUY_HERE'),VirtualmoneyHelperFormat::getConfigFormatCurrency()->codePlural)); ?>
    </a>
</p>
<table id="virtualmoney_transactiontable" class="table table-striped table-bordered">
<tr>
	<th align="center"><?php echo JText::_('COM_VIRTUALMONEY_TRANSACTION_CREATED_ON'); ?></th>
	<th align="center"><?php echo JText::_('COM_VIRTUALMONEY_TRANSACTION_DESCRIPTION'); ?></th>
	<th align="center"><?php echo JText::_('COM_VIRTUALMONEY_TRANSACTION_DEBIT'); ?></th>
	<th align="center"><?php echo JText::_('COM_VIRTUALMONEY_TRANSACTION_CREDIT'); ?></th>
</tr>
<?php foreach($this->transactions as $transaction) { 
?>
<tr>
	<td><?php echo VirtualmoneyHelperFormat::formattedDate($transaction->created_on);?></td>
    <td>
        <?php
            $description = JText::_($transaction->description);
            $description = str_replace('<br />', '', $description);
            $description = str_replace('&nbsp;', ' ', $description);
            echo nl2br(htmlspecialchars($description));
            if(isset($transaction->exchange)) {
                if($transaction->exchange->description != NULL && $transaction->exchange->description != ''){
                    $descriptionExchange = JText::_($transaction->exchange->description);
                    $descriptionExchange = str_replace('<br />', '', $descriptionExchange);
                    $descriptionExchange = str_replace('&nbsp;', ' ', $descriptionExchange);
                    echo "<br/>".JText::_('COM_VIRTUALMONEY_EXCHANGE_DESCRIPTION')." : <br/>";
                    echo nl2br(htmlspecialchars($descriptionExchange));
                }
            }
        ?>
    </td>
	<td align="right">
        <?php echo htmlspecialchars($transaction->debit); ?>
    </td>
	<td align="right">
        <?php echo htmlspecialchars($transaction->credit); ?>
    </td>
</tr>
<?php 
} ?>
            <?php if($this->pagination->total > 1) { ?>
<tr>
	<td colspan="4">
		<div class="pagination">
                        <?php echo $this->pagination->getPagesLinks(); ?>
		</div>
	</td>
            </tr>
            <?php } ?>
</table>
</form>
<script>
	jQ(function() {
		jQ( ".status" ).each(function() {
				jQ(this).attr("class","status "+ jQ(this).text().toLowerCase());
		});
	});
            </script>
        </fieldset>
    </div>
</div>