<?php
/**
 * @package		Virtualmoney
 * @copyright	Copyright (C) 2010-2014 Juloa. All rights reserved.
 * @license GNU General Public License version 3, or later
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );
?>
<?php
/**
 * @package		Invoicing
 *  @license GNU General Public License version 3, or later
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

require_once(JPATH_ADMINISTRATOR.'/components/com_invoicing/assets/paymentplugin.php');

class plgInvoicingpaymentVirtualmoney extends InvoicingAbstractPaymentPlugin
{
	public function __construct(&$subject, $config = array())
	{
		if(version_compare(JVERSION, '1.6', 'ge')) {
			$defaultimg = JURI::root().'plugins/invoicingpayment/virtualmoney/virtualmoney/virtualmoney.jpg';
		} else {
			$defaultimg = JURI::root().'plugins/invoicingpayment/virtualmoney/virtualmoney.jpg';
		}	
		
		$config = array_merge($config, array(
			'ppName'		=> 'virtualmoney',
			'ppKey'			=> 'PLG_INVOICINGPAYMENT_VIRTUALMONEY_TITLE',
			'ppImage'		=> $defaultimg)
				);
		
		parent::__construct($subject, $config);
	}
	
	function onInvoicingPaymentDisplay($paymentmethod,$data)
	{
		if($paymentmethod != $this->ppName) return false;
		
		$item =  FOFModel::getTmpInstance('Invoices', 'InvoicingModel')->getItem($data->invoicing_invoice_id);
		$item->save(array("processor"=>'virtualmoney'));
		
		$app = JFactory::getApplication();
		$db = JFactory::getDbo();
		
		$this->amount = $data->gross_amount;
		//$this->tax = $data->tax_amount;
		include_once(JPATH_ROOT.'/administrator/components/com_invoicing/helpers/format.php');
		$this->item_name = InvoicingHelperFormat::formatOrderNumber($data);
		$this->item_number = $data->invoicing_invoice_id;
		
		
		$this->config->changerate = $this->params->get('currencychangerate',1);
		$this->config->connection = $this->params->get('connection','');
        
        if($this->config->connection != "") {
            $this->config->connection = str_replace("\r","",$this->config->connection);
            $this->config->connection = explode("\n",$this->config->connection);
        }
        
		$currency =  FOFModel::getTmpInstance('Currencies', 'InvoicingModel')->getItem($data->currency_id);
		$this->currency_code = $currency->code;
		
		$this->baseurl = JURI::base();
		
		ob_start();
		include(dirname(__FILE__)."/virtualmoney/payment.php");
		$html = ob_get_clean();
		return $html;
	}
	
	public function onInvoicingPaymentNotification($paymentmethod, $data)
	{
		// Check if we're supposed to handle this
		if($paymentmethod != $this->ppName) return false;
        
        $app = JFactory::getApplication();
		
		InvoicingHelperLog::log("Virtualmoney Begin");
	
        $isValid = true;
        
        $id = array_key_exists('item_number', $data) ? (int)$data['item_number'] : -1;
        $targetLink = JRoute::_('index.php?option=com_invoicing&view=invoice&layout=payment&id='.$id.'&status=error');
        
        if($data['guest']) {
            InvoicingHelperLog::log("The user is a guest, payment stopped.");
            $isValid = false;
            $app->redirect($targetLink,JText::_('PLG_INVOICINGPAYMENT_VIRTUALMONEY_PAYMENT_GUEST'),'error');
        }
        if($data['changerate']) {
            InvoicingHelperLog::log("No change rate configured, payment stopped.");
            $isValid = false;
            $app->redirect($targetLink,JText::_('PLG_INVOICINGPAYMENT_VIRTUALMONEY_NO_CHANGERATE'),'error');
        }
        if($data['credits']) {
            InvoicingHelperLog::log("The user don't have enought virtual currency, payment stopped.");
            $isValid = false;
            $redirectCredits = $this->params->get('redirectcredits',0);
            if($redirectCredits)
                $targetLink = JRoute::_('index.php?option=com_virtualmoney&view=pack&status=error');
            
            $app->redirect($targetLink,JText::_('PLG_INVOICINGPAYMENT_VIRTUALMONEY_NOT_ENOUGHT_CREDITS'),'error');
        }
        
		if($isValid) {
			$amount = floatval($data['virtualamount']);
			$isGrossAmount = true;
			$currency = null;
            
            //We need to check the real amount without change rate to check the paiement
            $realAmount  = floatval($data['amount']);
            
			if ($this->checkValidity($id,$realAmount,$isGrossAmount,$currency) == true) {
                $coupon = new stdClass();
                $coupon->apply_on = "0";
                $coupon->valuetype = "value";
                $coupon->value = $realAmount;
                $coupon->invoicing_coupon_id = null;
                $model =  FOFModel::getTmpInstance('Invoices', 'InvoicingModel');
                $item =  $model->getItem($id);
                $model->setCoupon($coupon,$item);
                $this->validPayment($id,$paymentmethod);
			} else {
				$isValid = false;
			}
		}
		
        if($isValid) {
            $app->redirect('index.php?option=com_invoicing&view=message&layout=complete');
        }
        
		// Fraud attempt? Do nothing more!
		if(!$isValid) return false;
	}
    
    public function onInvoicingPaymentSelection($item) {
    	
    	include_once(JPATH_ROOT.'/components/com_virtualmoney/lib/core.php');
		
		$processor = $this->onInvoicingPaymentGetIdentity();
		
		$changerate = $this->params->get('currencychangerate',1);
		$connections = $this->params->get('connection','');
        
		$virtualPrice = 0;
        $realPrice = round($item->gross_amount, 2);
        if($connections != "") {
            $connections = str_replace("\r","",$connections);
            $connections = explode("\n",$connections);
			
			foreach($connections as $connection) {
				$tag = explode(":",$connection);
				if($tag[0] == $realPrice) {
					$virtualPrice = $tag[1];
				}
			}
        }
		if($virtualPrice == 0){
			$virtualPrice = $realPrice * $changerate;
			$virtualPrice = (int)$virtualPrice;
		}
		
		$virtualPrice = VirtualmoneyHelperFormat::formatPrice($virtualPrice); 
		
        $url = JRoute::_('index.php?option=com_invoicing&view=payment&id='.$item->invoicing_invoice_id.'&method='.$processor->name);
        if (InvoicingHelperCparams::getParam('use_paymentimage',1)==1) {
            return '<div class="paymentMeth"><a href="'.$url.'" class="paymentbutton"><div class="paymentImg "><img class="img-responsive" src="'.htmlspecialchars($processor->image).'" /></div><div class="paymentTxt">'.htmlspecialchars($processor->title).' - '.$virtualPrice.'</div></a></div>';
        }
        else {
            return '<div class="paymentMeth"><a href="'.$url.'" class="paymentbutton"><div class="paymentTxt">'.htmlspecialchars($processor->title).' - '.$virtualPrice.'</div></a></div>';
        }
    }
}
