<?php
/**
 * @package		Invoicing
 * @copyright	Copyright (C) 2010-2011 JoomPROD.com. All rights reserved.
 * @license GNU General Public License version 3, or later
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

?>
<?php 

$app = JFactory::getApplication();
$user = JFactory::getUser();

$isValid = true;
$data = array();
$data['guest']       = false;
$data['changerate']  = false;
$data['credits']     = false;
$data['item_number'] = $this->item_number;

if($user->guest) {
    $data['guest'] = true;
}

if(!isset($this->config->changerate) || $this->config->changerate <= 0) {
    $data['changerate'] = true;
}

include_once(JPATH_ROOT.'/administrator/components/com_virtualmoney/helpers/format.php');
include_once(JPATH_ROOT.'/administrator/components/com_virtualmoney/helpers/cparams.php');
include JPATH_ROOT.'/components/com_virtualmoney/lib/core.php';

$data['amount']          = round($this->amount,2);
$tagConnection = false;
if($this->config->connection != ''){
    foreach($this->config->connection as $k) {
        $connection = explode(':',$k);
        $connection[0] = round($connection[0],2);
        if($connection[0] == $data['amount']){
            $tagConnection = true;
            $data['virtualamount'] = $connection[1];
        }
    }
}
if(!$tagConnection)
    $data['virtualamount']   = round($this->amount,0) * (int)$this->config->changerate;

$data['currency'] = VirtualmoneyHelperFormat::getConfigFormatCurrency()->code;

if(!Virtualmoney::checkCredits($data['amount'],$user->id)) {
    $data['credits'] = true;
}

$description = JText::_('PLG_INVOICINGPAYMENT_VIRTUALMONEY_DESCRIPTION',$this->item_number,$this->item_name);

$transaction = Virtualmoney::removeCredits($user->id, $data['virtualamount'], $description, 'invoicingpayment', $this->item_number);

if(!$transaction){
    $data['credits'] = true;
}

$this->onInvoicingPaymentNotification('virtualmoney',$data);